/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation.
 * Portions created by the Initial Developer are Copyright (C) 1998
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Scott MacGregor <mscott@netscape.com>
 *   Jens Bannmann <jens.b@web.de>
 *   George Bradt
 *
 * Credit(s):
 *   Thanks to ReminderFox for pointing me to this code.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var SimpleClocksSliderAlert = {
    sliderQueue: [],
    application: null,
    finalHeight: 0,
    slideIncrement: 1,
    slideTime: 10,
    openTime: 0, // total time the alert should stay up once we are done animating. User-defined.

    // Entry, message to be displayed is passed in and added to the queue.
    // Use a queue to prevent overlapping windows.

    addMessageToQueue: function(msg) {
        SimpleClocksSliderAlert.application = Components.classes["@mozilla.org/fuel/application;1"].
                getService(Components.interfaces.fuelIApplication);

        if ( !SimpleClocksSliderAlert.application.storage.has("sliderQueue") ) {
            SimpleClocksSliderAlert.setSliderQueue();
        }

        SimpleClocksSliderAlert.getSliderQueue();
        SimpleClocksSliderAlert.sliderQueue.push(msg);
        SimpleClocksSliderAlert.setSliderQueue();

        if ( SimpleClocksSliderAlert.sliderQueue.length === 1 ) {
            // If length > 1, an alert already in progress.
            SimpleClocksSliderAlert.openSliderWindow();
        }
    },

    // Custom slider alert. The message is displayed in a small window that slides up
    // from the bottom of the screen, holds there for a few seconds (user-defined),
    // then slides down. Allows multi-line messages.

    openSliderWindow: function() {
        window.openDialog(
                "chrome://simpletimerClocks/content/simpletimerClocks-sliderAlert.xul",
                "",
                "chrome, dialog, titlebar=no, popup");
    },

    // Determine which alert to build the window for.
    // Done before the load routine, to allow proper sizing.

    prefillAlertInfo: function() {
        this.application = Components.classes["@mozilla.org/fuel/application;1"].
                getService(Components.interfaces.fuelIApplication);

        this.getSliderQueue();

        if ( this.sliderQueue[0].mode === "calEvent" ) {
            this.calEvent();
        }
        else {
            this.others();
        }
    },

    // Build the window for today's and upcoming calendar events.

    calEvent: function() {
        var strbundle = document.getElementById("simclk-strings");
        var rowNode, descrNodeDescription, timeNode, dateNode;

        document.getElementById("simclk-hboxSliderAlert0").collapsed = true;
        document.getElementById("simclk-hboxSliderAlert1").collapsed = false;

        document.getElementById("simclk-deckSliderAlert").selectedIndex = 1;

        var todayItems = this.sliderQueue[0].todayItems;
        var upcomingItems = this.sliderQueue[0].upcomingItems;

        // Today.
        var parent = document.getElementById("simclk-gridToday1");
        var oldRowsNode = parent.lastChild;
        var newRowsNode = document.createElement("rows");

        if ( todayItems.length > 0 ) {
            for ( var i in todayItems ) {

                rowNode = document.createElement("row");

                timeNode = document.createElement("description");
                timeNode.setAttribute("value", todayItems[i].timeDisplay);
                rowNode.appendChild(timeNode);

                descrNodeDescription = document.createElement("description");
                descrNodeDescription.setAttribute("value", '"' + todayItems[i].descrDisplay + '"');
                rowNode.appendChild(descrNodeDescription);

                newRowsNode.appendChild(rowNode);
            }
        }
        else {
            rowNode = document.createElement("row");

            descrNodeDescription = document.createElement("description");
            descrNodeDescription.setAttribute("value", strbundle.getString("msg.none"));
            rowNode.appendChild(descrNodeDescription);

            newRowsNode.appendChild(rowNode);
        }

        parent.replaceChild(newRowsNode, oldRowsNode);

        // Upcoming.
        parent = document.getElementById("simclk-gridUpcoming1");
        oldRowsNode = parent.lastChild;
        newRowsNode = document.createElement("rows");

        if ( upcomingItems.length > 0 ) {
            for ( var i in upcomingItems ) {

                rowNode = document.createElement("row");

                dateNode = document.createElement("description");
                dateNode.setAttribute("value", upcomingItems[i].startDateDisplay);
                rowNode.appendChild(dateNode);

                timeNode = document.createElement("description");
                timeNode.setAttribute("value", upcomingItems[i].timeDisplay);
                rowNode.appendChild(timeNode);

                descrNodeDescription = document.createElement("description");
                descrNodeDescription.setAttribute("value", '"' + upcomingItems[i].descrDisplay + '"');
                rowNode.appendChild(descrNodeDescription);

                newRowsNode.appendChild(rowNode);
          }
        }
        else {
            rowNode = document.createElement("row");

            descrNodeDescription = document.createElement("description");
            descrNodeDescription.setAttribute("value", strbundle.getString("msg.none"));
            rowNode.appendChild(descrNodeDescription);

            newRowsNode.appendChild(rowNode);
        }

        parent.replaceChild(newRowsNode, oldRowsNode);
    },

    // Build the window for all alerts except calendar events.

    others: function() {
        var strbundle = document.getElementById("simclk-strings");
        var rowNode, descrNodeTime, descrNodeDescription;

        document.getElementById("simclk-hboxSliderAlert1").collapsed = true;
        document.getElementById("simclk-hboxSliderAlert0").collapsed = false;

        document.getElementById("simclk-deckSliderAlert").selectedIndex = 0;

        var displayItems = this.sliderQueue[0].displayItems;
        document.getElementById("simclk-descMessage0").value = this.sliderQueue[0].msg;

        var parent = document.getElementById("simclk-gridItems0");
        var oldRowsNode = parent.lastChild;
        var newRowsNode = document.createElement("rows");

        if ( displayItems.length > 0 ) {
            for ( var i in displayItems ) {
                rowNode = document.createElement("row");

                descrNodeTime = document.createElement("description");
                descrNodeTime.setAttribute("value", displayItems[i].timeDisplay);
                rowNode.appendChild(descrNodeTime);

                descrNodeDescription = document.createElement("description");
                descrNodeDescription.setAttribute("value", displayItems[i].description);
                rowNode.appendChild(descrNodeDescription);

                newRowsNode.appendChild(rowNode);

                if ( i === "7" && displayItems.length > 8 ) {
                    // Eight items should be enough.
                    rowNode = document.createElement("row");

                    descrNodeTime = document.createElement("description");
                    descrNodeTime.setAttribute("value", strbundle.getString("msg.etc"));
                    rowNode.appendChild(descrNodeTime);

                    newRowsNode.appendChild(rowNode);
                    break;
                }
            }
        }

        parent.replaceChild(newRowsNode, oldRowsNode);
    },

    // Size and position window.

    onAlertLoad: function() {
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                getService(Components.interfaces.nsIPrefService).
                getBranch("extensions.simpletimerClocks@grbradt.org.");
        var alertSliderMaxHeight;

        sizeToContent();

        this.finalHeight = window.outerHeight;
        window.outerHeight = 1;
        this.openTime = prefs.getIntPref("holdPopup") * 1000;

        // Be sure to offset the alert by 10 pixels from the far right edge of the screen.
        window.moveTo( (screen.availLeft + screen.availWidth - window.outerWidth) - 10,
                        screen.availTop + screen.availHeight - window.outerHeight);

        setTimeout("SimpleClocksSliderAlert.animateAlert()", this.slideTime);
    },

    // Moving the window up.

    animateAlert: function() {
        if ( window.outerHeight < this.finalHeight ) {
            window.screenY -= this.slideIncrement;
            window.outerHeight += this.slideIncrement;
            setTimeout("SimpleClocksSliderAlert.animateAlert()", this.slideTime);
        }
        else {
            setTimeout("SimpleClocksSliderAlert.closeAlert()", this.openTime);
        }
    },

    // Moving the window down.

    closeAlert: function() {
        if ( window.outerHeight > 1 ) {
            window.screenY += this.slideIncrement;
            window.outerHeight -= this.slideIncrement;
            setTimeout("SimpleClocksSliderAlert.closeAlert()", this.slideTime);
        }
        else {
            this.getSliderQueue();
            this.sliderQueue.shift();
            this.setSliderQueue();

            if ( this.sliderQueue.length === 0 ) {
                window.close();
            }
            else {
                // Process next in queue.
                this.prefillAlertInfo();
                this.onAlertLoad();
            }
        }
    },

    // Retrieve the global.

    getSliderQueue: function() {
        SimpleClocksSliderAlert.sliderQueue = SimpleClocksSliderAlert.application.storage.get("sliderQueue", "ERR");
    },

    // Update the global.

    setSliderQueue: function() {
        SimpleClocksSliderAlert.application.storage.set("sliderQueue", SimpleClocksSliderAlert.sliderQueue);
    },

    // Check if other browser windows open.
    // Don't display the startup alerts if true.
    // Called from SimpleClocksNotify and SimpleClocksCountdown.

    otherBrowserWindowOpen: function() {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
        var wmi = wm.QueryInterface(Components.interfaces.nsIWindowMediator);
        var enumerator = wmi.getEnumerator("navigator:browser");

        if ( enumerator.hasMoreElements() ) {
            // Don't include current window.
            enumerator.getNext();
        }

        return enumerator.hasMoreElements();
    },

    // Debug messages to console.

    debug: function(aMsg) {
        setTimeout(function() { throw new Error("[debug] " + aMsg); }, 0);
    }
};